from dataclasses import (
    dataclass,
)


@dataclass
class PhpComposerExternalReference:
    type: str
    url: str
    reference: str
    shasum: str | None = None


@dataclass
class PhpComposerAuthors:
    name: str
    email: str | None = None
    homepage: str | None = None


@dataclass
class PhpComposerLockEntry:  # pylint: disable=too-many-instance-attributes
    name: str
    version: str
    source: PhpComposerExternalReference
    dist: PhpComposerExternalReference
    require: dict[str, str] | None = None
    provide: dict[str, str] | None = None
    require_dev: dict[str, str] | None = None
    suggest: dict[str, str] | None = None
    license: list[str] | None = None
    type: str | None = None
    notification_url: str | None = None
    bin: list[str] | None = None
    authors: list[PhpComposerAuthors] | None = None
    description: str | None = None
    homepage: str | None = None
    keywords: list[str] | None = None
    time: str | None = None


# PhpComposerInstalledEntry is an alias for PhpComposerLockEntry
PhpComposerInstalledEntry = PhpComposerLockEntry


@dataclass
class PhpPeclEntry:
    name: str
    version: str
    license: list[str] | None = None
